(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_alldiff.mli,v 1.11 2001/01/29 10:40:35 brisset Exp $ *)

(* Module [Alldiff]: the "All Different" constraint  *)

type algo = Lazy | Bin_matching of Fcl_var.Attr.event
val cstr : ?algo:algo -> Fcl_var.Fd.t array -> Fcl_cstr.t
(* [alldiff (?algo:Lazy) vars] States that variables of [vars] are different
   from each other. The optional argument [algo] specifies the level of
   propagation.
   [Lazy]: waits for instantiation and removes from other domains.
   [Bin_matching c]: waits for event [c] (e.g. [Var.Attr.on_refine])
   and uses a bin matching algorithm to ensure the constraint is
   consistent. [algo] default value is [Lazy].
   Not reifiable. *)
