(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
let level = ref (try Sys.getenv "CAMLDEBUG" with Not_found -> "");;
let log = ref stdout;;
let call lev f =
  assert(if !level = "*" || String.contains !level lev then begin f !log ;flush !log end; true);;

let internal_error mesg =
  failwith (Printf.sprintf "Internal error (%s). Please send a bug report to facile@recherche.enac.fr" mesg)

let fatal_error mesg =
  failwith (Printf.sprintf "Fatal error: %s" mesg)
