(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_debug.mli,v 1.6 2000/12/20 16:39:47 brisset Exp $ *)

(* Module [Debug]: debugging facilities *)

(* _Undocumented_
   Already used characters :
     c : Cstr
     g : Goals
     d : Gcc
     a : Arith
     e : Element
*)

val level : string ref
(* _Undocumented_
   Equals to environement variable CAMLDEBUG if set, else "" *)
val log : out_channel ref
(* _Undocumented_
   Initialized to stdout *)
val call : char -> (out_channel -> unit) -> unit
(* _Undocumented_
   [call lev f] if [lev] belongs to [!level] or [level]="*", function [f] is
   applied to [!log]. Discarded (if inlined) with the -noassert compiler
   option. *)

val internal_error : string -> 'a
(* Implementor's error *)
val fatal_error : string -> 'a
(* User's error *)
