(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_fdArray.mli,v 1.11 2001/01/29 14:10:09 brisset Exp $ *)

(* Module [FdArray]: constraints over arrays of variables *)

val min : Fcl_var.Fd.t array -> Fcl_var.Fd.t
(* [min_array vars] returns a variable constrained to be equal to the variable
   that will be instantiated to the minimal value among all the variables in
   the array [vars]. Raises [Invalid_argument] if [vars] is empty.
   Not reifiable. *)
val min_cstr : Fcl_var.Fd.t array -> Fcl_var.Fd.t -> Fcl_cstr.t
(* [min_cstr vars mini] return thes constraint
   [fd2e (min vars) =~ fd2e mini]. Raises [Invalid_argument] if [vars] is empty.
   Not reifiable. *) 
val max : Fcl_var.Fd.t array -> Fcl_var.Fd.t
(* Idem as [min] but for the maximal value. *)
val max_cstr : Fcl_var.Fd.t array -> Fcl_var.Fd.t -> Fcl_cstr.t
(* Idem as [min_cstr] but for the maximal value. *)
val get : Fcl_var.Fd.t array ->  Fcl_var.Fd.t -> Fcl_var.Fd.t
(* [get vars index] returns a variable constrained to be equal to
   [vars.(index)]. Raises [Invalid_argument] if [vars] is empty.
   Not reifiable. *)
val get_cstr : Fcl_var.Fd.t array -> Fcl_var.Fd.t -> Fcl_var.Fd.t -> Fcl_cstr.t
(* [get_cstr vars index v] returns the constraint
   [fd2e vars.(index) =~ fd2e v]. Raises [Invalid_argument] if [vars] is empty.
   Not reifiable. *)

