(***********************************************************************)
(*                                                                     *)
(*                           FaCiLe                                    *)
(*                                                                     *)
(*            Nicolas Barnier, Pascal Brisset, LOG, ENAC/CENA          *)
(*                                                                     *)
(***********************************************************************)
(* $Id: fcl_opti.ml,v 1.6 2000/12/14 15:32:29 brisset Exp $ *)

open Fcl_var
open Fcl_arith
open Fcl_goals

let minimize goal (cost : Fd.t) ?control ?(step = 1) compute_solution =
  let solution = ref None
  and best_cost = ref (Fd.max cost + 1) in
  try
    let bound = fun () -> Fcl_cstr.post (fd2e cost <=~ i2e (!best_cost - step)) in
    while solve ?control (create bound &&~ goal) do
      let m = Fd.min cost in
      Fd.unify cost m;
      solution := Some (compute_solution m);
      Fcl_stak.backtrack_all ();
      best_cost := m
    done;
    !solution
  with Exit -> !solution;;
